Index: indications.c
===================================================================
RCS file: /usr/cvsroot/asterisk/indications.c,v
retrieving revision 1.4
diff -u -r1.4 indications.c
--- indications.c       13 Aug 2003 15:25:16 -0000      1.4
+++ indications.c       15 Sep 2003 00:30:22 -0000
@@ -31,6 +31,7 @@
        int freq1;
        int freq2;
        int duration;
+       int modulation;
 };
 
 struct playtones_def {
@@ -103,10 +104,14 @@
 
        pi = &ps->items[ps->npos];
        for (x=0;x<len/2;x++) {
-               ps->data[x] = ps->vol * (
-                               sin((pi->freq1 * 2.0 * M_PI / 8000.0) * (ps->pos + x)) +
-                               sin((pi->freq2 * 2.0 * M_PI / 8000.0) * (ps->pos + x))
-                       );
+
+               double partA = sin((pi->freq1 * 2.0 * M_PI / 8000.0) * (ps->pos + x));
+               double partB = sin((pi->freq2 * 2.0 * M_PI / 8000.0) * (ps->pos + x));
+
+               if(pi->modulation)
+                       ps->data[x] = ps->vol * (partA * partB);
+               else
+                       ps->data[x] = ps->vol * (partA + partB);
        }
        ps->f.frametype = AST_FRAME_VOICE;
        ps->f.subclass = AST_FORMAT_SLINEAR;
@@ -157,17 +162,27 @@
                separator = ",";
        s = strsep(&stringp,separator);
         while(s && *s) {
-               int freq1, freq2, time;
+               int freq1, freq2, time, modulation;
+
+               modulation = 0;
 
                if (s[0]=='!')
                        s++;
                else if (d.reppos == -1)
                        d.reppos = d.nitems;
+
                if (sscanf(s, "%d+%d/%d", &freq1, &freq2, &time) == 3) {
                        /* f1+f2/time format */
                } else if (sscanf(s, "%d+%d", &freq1, &freq2) == 2) {
                        /* f1+f2 format */
                        time = 0;
+               } else if (sscanf(s, "%d*%d/%d", &freq1, &freq2, &time) == 3) { 
+                        /* f1*f2/time format */
+                       modulation = 1;
+               } else if (sscanf(s, "%d*%d", &freq1, &freq2) == 2) { 
+                        /* f1*f2 format */
+                       modulation = 1;
+                        time = 0;
                } else if (sscanf(s, "%d/%d", &freq1, &time) == 2) {
                        /* f1/time format */
                        freq2 = 0;
@@ -186,6 +201,7 @@
                d.items[d.nitems].freq1    = freq1;
                d.items[d.nitems].freq2    = freq2;
                d.items[d.nitems].duration = time;
+               d.items[d.nitems].modulation = modulation;
                d.nitems++;
 
                s = strsep(&stringp,separator);